;;;; -*- lisp -*-

(in-package :it.bese.yaclml)

(5am:def-suite :it.bese.yaclml.tal)

(5am:in-suite :it.bese.yaclml.tal)

(defun tal-compile&run (tal-string env)
  (with-output-to-string (tal)
    (with-yaclml-stream tal
      (funcall (compile-tal-string tal-string) env))))

(5am:test non-tal
  (5am:is (string= "<a/>" (tal-compile&run "<a/>" nil)))
  (5am:is (string= "<a><span/></a>" (tal-compile&run "<a><span/></a>" nil)))
  (5am:is (string= "<pre>
  one

two
</pre>"
		   (tal-compile&run "

<pre>
  one

two
</pre>" nil))))

(5am:test tal-when
  (5am:is (string= "<a href=\"4\">OK!</a>" (tal-compile&run "<a href=\"4\" tal:when=\"$c\">OK!</a>"
							    `(:c t))))
  (5am:is (string= "<a href=\"4\">OK!</a>" (tal-compile&run  "<a href=\"4\" tal:when=\"(not $c)\">OK!</a>"
							     '(:c nil))))
  (5am:is (string= "<a href=\"4\">OK!</a>" (tal-compile&run  "<a href=\"4\" tal:when=\"(not $c)\">OK!</a>"
							     nil))))

(5am:test tal-replace
  (5am:is (string= "OK!" (tal-compile&run "<a href=\"4\" tal:replace=\"$c\"></a>" '(:c "OK!")))))

(5am:test tal-content
  (5am:is (string= "<a>OK!</a>" (tal-compile&run "<a tal:content=\"$c\">BAD BAD BAD</a>"
						 '(:C "OK!")))))
